; A set of misc. tools
; ===========================================================================

; Makes a relative path global
(define (global x) (string-append path x))

; A relative path version of load
(define (include x) (load (global x)))

; Reload everything
(define (l) (load (global "lll.scm")))

; Shortcut for MIT-Scheme
(define (r) (restart 1))

; Something to make loose ends obvious
(define (******)
  (error "Execution has reached the unimplemented expression ******"))

(define (compile prog target file)
  (call-with-output-file (global file)
    (lambda (port)
      (display-asm prog target port))))

; ---------------------------------------------------------------------------
; A few mathematical extentions
; ---------------------------------------------------------------------------

; returns (quotient n 2^i)  (right-shift)
(define (>> n i)
  (if (= i 0) n (>> (quotient n 2) (- i 1))))

; returns (* n 2^i)  (left-shift)
(define (<< n i)
  (if (= i 0) n (<< (* n 2) (- i 1))))

(define (bitwise-or a b)
  (if (= a 0)
      b
      (+ (max (modulo a 2) (modulo b 2))
	 (* 2 (bitwise-or (quotient a 2) (quotient b 2))))))

(define (bitwise-and a b)
  (if (= a 0)
      0
      (+ (min (modulo a 2) (modulo b 2))
	 (* 2 (bitwise-and (quotient a 2) (quotient b 2))))))

; ---------------------------------------------------------------------------
; Error messages and error handling
; ---------------------------------------------------------------------------

(define (assert predicate object)
  (if (predicate object)
      object
      (Error "Object failed assertion :" object)))

(define unsupported-target
  "This construct doesn't support the specified target language.")

